org.cpsolver.coursett.criteria

## Class TimetablingCriterion

- java.lang.Object
- - org.cpsolver.ifs.criteria.AbstractCriterion<Lecture,Placement>
  - - org.cpsolver.coursett.criteria.TimetablingCriterion

- All Implemented Interfaces:
    CanHoldContext, HasAssignmentContext<Lecture,Placement,AbstractCriterion.ValueContext>, Criterion<Lecture,Placement>, ExtendedInfoProvider<Lecture,Placement>, InfoProvider<Lecture,Placement>, ModelListener<Lecture,Placement>
  Direct Known Subclasses:
    BackToBackInstructorPreferences, BrokenTimePatterns, DistributionPreferences, FlexibleConstraintCriterion, InstructorConflict, InstructorFairness, InstructorLunchBreak, Perturbations, PlacementSelectionCriterion, RoomPreferences, RoomSizePenalty, RoomViolations, SameSubpartBalancingPenalty, StudentConflict, TimePreferences, TooBigRooms

      public abstract class TimetablingCriterion
      extends AbstractCriterion<Lecture,Placement>

  Abstract class for all timetabling criteria. On top of the `AbstractCriterion`, it provides weights for the `PlacementSelection` heuristics.
  Version:
    CourseTT 1.3 (University Course Timetabling)
    Copyright (C) 2006 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.cpsolver.ifs.criteria.AbstractCriterion

      `AbstractCriterion.ValueContext, AbstractCriterion.ValueUpdateType`

  - ### Field Summary

    - ### Fields inherited from class org.cpsolver.ifs.criteria.AbstractCriterion

      `iBest, iDebug, iWeight, sDoubleFormat, sPercentFormat`

    - ### Fields inherited from interface org.cpsolver.ifs.assignment.context.CanHoldContext

      `sMaxSize`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TimetablingCriterion()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `configure(DataProperties properties)` Configure the criterion if needed
    `String` | `getPlacementSelectionAdjustmentsName()`
    `double` | `getPlacementSelectionWeight(int level, int idx)`
    `double` | `getPlacementSelectionWeightDefault(int level)`
    `String` | `getPlacementSelectionWeightName()`

    - ### Methods inherited from class org.cpsolver.ifs.criteria.AbstractCriterion

      `afterAssigned, afterUnassigned, beforeAssigned, beforeUnassigned, bestRestored, bestSaved, clearCache, computeBounds, constraintAdded, constraintRemoved, createAssignmentContext, getAbbreviation, getAssignmentContextReference, getBest, getBounds, getBounds, getBounds, getBounds, getContext, getContext, getExtendedInfo, getInfo, getInfo, getModel, getName, getPerc, getPercentage, getPercRev, getValue, getValue, getValue, getValue, getValueUpdateType, getWeight, getWeightDefault, getWeightedBest, getWeightedValue, getWeightedValue, getWeightedValue, getWeightedValue, getWeightedValue, getWeightedValue, getWeightName, inc, inc, init, setAssignmentContextReference, setModel, setValueUpdateType, toString, variableAdded, variableRemoved`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.cpsolver.ifs.criteria.Criterion

      `getValue`

- - ### Constructor Detail

    - #### TimetablingCriterion

          public TimetablingCriterion()

  - ### Method Detail

    - #### configure

          public void configure(DataProperties properties)

      Description copied from interface: `Criterion`
      Configure the criterion if needed
      Specified by:
        `configure` in interface `Criterion<Lecture,Placement>`
      Overrides:
        `configure` in class `AbstractCriterion<Lecture,Placement>`
      Parameters:
        `properties` - configuration

    - #### getPlacementSelectionWeightName

          public String getPlacementSelectionWeightName()

    - #### getPlacementSelectionAdjustmentsName

          public String getPlacementSelectionAdjustmentsName()

    - #### getPlacementSelectionWeight

          public double getPlacementSelectionWeight(int level,
                                                    int idx)

    - #### getPlacementSelectionWeightDefault

          public double getPlacementSelectionWeightDefault(int level)